﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace SimpleAsync
{
    class Program
    {
        public static void Main(string[] args)
        {
            Task.Run(async () =>
            {
                Console.WriteLine("In Main before await");
                await Main();
                Console.WriteLine("In Main after await");
            }).GetAwaiter().GetResult();
            Console.WriteLine("We can finish here");
            Console.ReadLine();
        }

        public static async Task Main()
        {
            var onetPageLengthTask = AccessTheWebAsync();

            Thread.Sleep(1000); /// if this time is shorter than page loading, we will see that page loaded before "in main task before await"/jeżeli ten czas będzie krótszy niż ładowanie strony to wyświetli nam się, że strona załadowana zanim w main task przed await
            Console.WriteLine("In main task before await");
            var result = await onetPageLengthTask;
            Console.WriteLine("In main task after await");
            Console.WriteLine("We read {0} bytes", result);
        }

        private static async Task<int> AccessTheWebAsync()
        {
            var client = new HttpClient();

            Task<string> getStringTask = client.GetStringAsync("http://onet.pl");
            Console.WriteLine("In AccessTheWebAsync before await");
            string urlContents = await getStringTask;
            Console.WriteLine("In AccessTheWebAsync after await");
           // Console.WriteLine($"{urlContents}"); //if we are very curious about what we really receive, it can be commented out.
            return urlContents.Length;
        }
    }
}
